//----------------------------------------------------------------------//
// NyanFi																//
//  fBNg(or X^bN)										//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include "UserFunc.h"
#include "Global.h"
#include "MainFrm.h"
#include "HistDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDirHistoryDlg *DirHistoryDlg;

//---------------------------------------------------------------------------
__fastcall TDirHistoryDlg::TDirHistoryDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormCreate(TObject *Sender)
{
	ListScrPanel = new UsrScrollPanel(ListPanel, DirHistListBox, USCRPNL_FLAG_P_WP | USCRPNL_FLAG_L_WP);

	IsDirStack = IsAllDirHist = false;
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	RefListTag	 = CurListTag;
	WorkListName = EmptyStr;

	set_StdListBox(DirHistListBox);
	set_UsrScrPanel(ListScrPanel);

	int *h_ptr = (IsDirStack || IsAllDirHist)? NULL : get_DirHistPtr(CurTabIndex, CurListTag);
	UpdateListBox(h_ptr? *h_ptr : 0);
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	IsDirStack = IsAllDirHist = false;

	IniFile->SavePosInfo(this);
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormDestroy(TObject *Sender)
{
	delete ListScrPanel;
}

//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::UpdateListBox(int idx)
{
	TListBox *lp = DirHistListBox;
	lp->Clear();

	UnicodeString tit;
	if (IsDirStack) {
		tit.USET_T("fBNgEX^bN");
		lp->PopupMenu = NULL;
	}
	else if (IsAllDirHist) {
		tit.USET_T("fBNg - S");
		lp->PopupMenu = AllHistPopupMenu;
	}
	else {
		tit.sprintf(_T("fBNg - %s"), get_LRUD_str(RefListTag));
		if (RefListTag!=CurListTag) tit.UCAT_T(" (ΑQ)");
		lp->PopupMenu = HistPopupMenu;
	}
	Caption = tit;

	TStringList *h_lst = IsDirStack? DirStack : IsAllDirHist? AllDirHistory : get_DirHistory(CurTabIndex, RefListTag);
	if (h_lst) {
		for (int i=0; i<h_lst->Count; i++) {
			UnicodeString lbuf = get_csv_item(h_lst->Strings[i], 0);
			if (UncToNetDrive) lbuf = UNC_to_NetDriveName(lbuf);
			if (DispRegName)   lbuf = get_RegDirName(lbuf);
			lp->Items->Add(yen_to_slash(lbuf));
		}
	}

	if (lp->Count>0) lp->ItemIndex = (idx<lp->Count)? idx : lp->Count -1;
	lp->SetFocus();

	ListScrPanel->UpdateKnob();
}

//---------------------------------------------------------------------------
//ڂ̕`
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxDrawItem(TWinControl *Control, int Index,
		TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas *cv = lp->Canvas;
	cv->Font->Assign(ListFont);
	cv->Brush->Color = col_bgList;
	cv->FillRect(Rect);

	int xp = Rect.Left + 2;
	int yp = Rect.Top + get_TopMargin2(cv);

	if (Index<9) {
		cv->Font->Color = col_fgList;
		cv->Font->Style = cv->Font->Style << fsUnderline;
		cv->TextOut(xp, yp, UnicodeString().sprintf(_T("%u"), Index + 1));
	}
	cv->Font->Style = cv->Font->Style >> fsUnderline;
	xp += get_CharWidth(cv, 2);
	cv->Font->Color = col_Folder;
	cv->TextOut(xp, yp, lp->Items->Strings[Index]);

	//J[\
	draw_ListCursor(lp, Rect, Index, State);
}

//---------------------------------------------------------------------------
//L[
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxKeyDown(TObject *Sender, WORD &Key,
		TShiftState Shift)
{
	TListBox *lp = (TListBox*)Sender;
	UnicodeString KeyStr = get_KeyStr(Key, Shift);
	UnicodeString CmdStr = Key_to_CmdF(KeyStr);
	bool handled = true;

	TStringList *h_lst = IsDirStack? DirStack : IsAllDirHist? AllDirHistory : get_DirHistory(CurTabIndex, RefListTag);
	int *h_ptr = (IsDirStack || IsAllDirHist)? NULL : get_DirHistPtr(CurTabIndex, CurListTag);

	try {
		if (!h_lst) Abort();

		//m
		if (is_Num1to9(KeyStr) || equal_ENTER(KeyStr)) {
			int idx = is_Num1to9(KeyStr)? KeyStr.ToIntDef(0) - 1 : lp->ItemIndex;
			if (idx<0 || idx>=h_lst->Count) Abort();
			UnicodeString dnam = get_csv_item(h_lst->Strings[idx], 0);
			//fBNg
			if (ends_PathDlmtr(dnam)) {
				if (dir_exists(dnam)) {
					bool is_cur = (RefListTag==CurListTag);
					if (is_cur && h_ptr) *h_ptr = idx;
					NyanFiForm->UpdateCurPath(dnam, -1, is_cur);
					ModalResult = mrOk;
				}
				else {
					msgbox_WARN(USTR_NotFound);
					h_lst->Delete(idx);  UpdateListBox(idx);
				}
			}
			//[NXg
			else if (test_NwlExt(get_extension(dnam))) {
				WorkListName = dnam;
				ModalResult  = mrOk;
			}
		}
		//ڂ̍폜
		else if (equal_DEL(KeyStr) || USAME_TI(CmdStr, "Delete")) {
			int idx = lp->ItemIndex;	if (idx==-1) Abort();
			h_lst->Delete(idx);
			UpdateListBox(idx);
		}
		//Α̗Q
		else if (equal_RIGHT(KeyStr) || contained_wd_i(_T("ToRight|ToParentOnRight"), CmdStr)) {
			if (h_ptr && RefListTag==0) {
				RefListTag = 1;
				int *h_p = get_DirHistPtr(CurTabIndex, RefListTag);
				if (h_p) UpdateListBox(*h_p);
			}
		}
		else if (equal_LEFT(KeyStr) || contained_wd_i(_T("ToLeft|ToParentOnLeft"), CmdStr)) {
			if (h_ptr && RefListTag==1) {
				RefListTag = 0;
				int *h_p = get_DirHistPtr(CurTabIndex, RefListTag);
				if (h_p) UpdateListBox(*h_p);
			}
		}
		//J[\ړ
		else if	(ExeCmdListBox(lp, CmdStr))			;
		//
		else if (USAME_TI(CmdStr, "ReturnList"))	ModalResult = mrCancel;
		else handled = false;
	}
	catch (EAbort &e) {
		beep_Warn();
	}

	if (!is_DialogKey(Key) || handled) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	//CN^T[`
	if (_istalnum(Key)) Key = 0;
}
//---------------------------------------------------------------------------
//}EX
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxDblClick(TObject *Sender)
{
	perform_Key_RETURN((TControl*)Sender);
}

//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift);
}

//---------------------------------------------------------------------------
//ׂč폜
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::ClearAllItemClick(TObject *Sender)
{
	if (msgbox_Sure(LoadUsrMsg(USTR_DelHistoryQ, get_LRUD_str().UCAT_T("")))) {
		DirHistListBox->Clear();
		clear_DirHistory(CurTabIndex, CurListTag);
	}
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::AllClearAllItemClick(TObject *Sender)
{
	if (msgbox_Sure(LoadUsrMsg(USTR_DelHistoryQ, _T("S")))) {
		DirHistListBox->Clear();
		AllDirHistory->Clear();
	}
}

//---------------------------------------------------------------------------
//ɓȂpX̐ݒ
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::NoHistItemClick(TObject *Sender)
{
	if (input_query_ex(_T("ɓȂpX̐ݒ"), null_TCHAR, &NoDirHistPath, 0, false, "; ŋ؂ĕw")) {
		if (!NoDirHistPath.IsEmpty()) {
			int cur_idx = DirHistListBox->ItemIndex;

			TStringList *h_lst = get_DirHistory(CurTabIndex, RefListTag);
			if (h_lst) {
				TStringDynArray path_lst = split_strings_semicolon(NoDirHistPath);
				int idx = 0;
				while (idx<h_lst->Count) {
					UnicodeString dnam = get_csv_item(h_lst->Strings[idx], 0);
					for (int i=0; i<path_lst.Length && !dnam.IsEmpty(); i++) {
						if (path_lst[i].IsEmpty()) continue;
						if (ContainsText(dnam, path_lst[i])) dnam = EmptyStr;
					}

					if (dnam.IsEmpty()) {
						h_lst->Delete(idx);
						if (cur_idx>=idx) cur_idx--;
					}
					else idx++;
				}
			}

			UpdateListBox(cur_idx);
		}
	}
}
//---------------------------------------------------------------------------

